      subroutine th_11indexsad(isubthe,icase,iput,iget,info) 
!     sad= source,absorber,detector : lstr1case=1,2,3      
      use glbconst, only: maxfr1,maxfr2,maxthss,maxscrd,ivstrf,icstrf
      use comthe, only: array_fr,theoryname,mLG,lstr1case
      implicit none 

      integer, intent(inout):: isubthe   
      integer, intent(in)   :: icase,iput,iget
      integer, intent(out)  :: info
                                                               
      integer       ibe,nAS,nSC,idum,ien                                        
      real          srw8 
      common/strLOC/ibe(15),nAS,nSC,idum(3),srw8,ien(11)
                                                                        
      logical       b_vs,b_v_max,b_dumvsp 
      common/bvstrf/b_vs(4),b_v_max,b_dumvsp(ivstrf-5) 
      real          c1,gamnat,e_xsi,flag_SAMP,flag_Voigt,dumcm 
      common/acmaps/c1,gamnat,e_xsi,flag_SAMP,flag_Voigt,dumcm(icstrf-5) 
      real          avm,shift,dumvm 
      common/avmaps/avm(2),shift,dumvm(ivstrf-3) 
      logical       b_vm,b_shift,b_dumvm 
      common/bvmaps/b_vm(2),b_shift,b_dumvm(ivstrf-3) 
                                                                        
      logical   b_pc,b_Gauss 
      integer   iflag_Voigt,i,i1,i2,n,ni,nst,jge
      real      hr,hti,srw 
      complex   hc,hci
      real,     dimension(:),allocatable :: Eagd,rtr,sTr,w_Gauss,w_Lorentz
      complex, dimension(:), allocatable :: cLG
                                                                        
      if(isubthe.lt.0) then 
       theoryname='1x1_ref_index_static_sad       v=100' 
       if(-isubthe.eq.1) then 
        c1=2*(nSC+1)+1 
       end if 
       if(-isubthe.eq.2) c1=2*(nAS+1) 
       if(-isubthe.eq.3) c1=2*(nSC+1) 
!       write(6,'(a,3i6,f12.2)')'th_11refindex :',-isubthe,nSC,nAS,c1   
       return 
      end if 
!     storage use nst2_8 for 4 complex numbers of r_ik                  
                                                                        
      hci=cmplx(0.,1.) 
      iflag_Voigt=flag_Voigt 
      nst=4 
                                                                        
!     only line positions are taken                                     
!     write(6,'(a,2i4)') 'th_11refindex avsstrf 1 jge=',jge           
!     write(6,'(10f10.2)') avss,shift,fr_Gauss,fr_Lorentz             
       call get_theory(isubthe,info) 
       if(info.gt.0) return 
        b_pc=b_v_max.or.isubthe.ge.0.or.b_vm(1) 
        if(.not.b_pc) then 
         isubthe=-abs(isubthe) 
         return 
        end if 
        isubthe=abs(isubthe) 
       if(icase.eq.0) print'(a)','icase not defined in str routine'
       

       i1=iget+1 
       jge=real(array_fr(i1)) 
       allocate(Eagd(jge),rtr(jge),w_Gauss(jge),w_Lorentz(jge))      

       i2=i1+jge 
       do i=1,jge 
        Eagd(i)=real(array_fr(i1+i))+shift 
        rtr(i)=aimag(array_fr(i1+i)) 
        w_Gauss(i)=real(array_fr(i2+i)) 
        w_Lorentz(i)=aimag(array_fr(i2+i)) 
       end do 
!      write(6,'(8f10.3)') (Eagd(i),i=1,jge), (w_Lorentz(i),i=1,jge) 
!      write(6,'(8f10.3)') (rtr(i),i=1,jge)                            
       b_Gauss=.true. 
                                                                        
!---------------------------- source ---------------------------------          
  select case(lstr1case)
    case(1)
     
        allocate(cLG(-nSC:nSC),sTr(-nSC:nSC))

!       write(6,'(a,i7)') 'ch_case(1:6).eq.source iput=',iput           
        do n=iput+1,iput+(nSC+1)*2 
         array_fr(n)=(0.,0.) 
        end do 
                                                                        
        srw=4.0*srw8 
        do i=1,jge 
         call aLORGAU(Eagd(i),gamnat,e_xsi,                             &
                       srw,w_Lorentz(i),w_Gauss(i),iflag_Voigt,nSC,cLG)    
!       write(6,'(a,i2,i5,a,6f12.4)')'i,nSC=',i,nSC,                   
!       ' th_subrmoss gamnat,srw,w_Lorentz,w_Gauss=',                  
!       gamnat,srw,w_Lorentz(i),w_Gauss(i)                           
         do n=0,nSC 
          ni=iput+2*n 
          array_fr(ni+1)=array_fr(ni+1)+cmplx(0.,aimag(cLG(n))*rtr(i)) 
          array_fr(ni+2)=array_fr(ni+2)+cmplx(0.,aimag(cLG(-n))*rtr(i)) 
         end do       ! n loop
        end do        ! i=1,jge

!       write(6,'(a,2i6)') ' th_11ref - source, iput,nSC=',iput,nSC     
!       write(6,'(4f15.6)') (rtr(i),i=1,jge)                            
                                                                        
!       The sum of the Lorentz-Gauss curves of the jge lines            
!       have to be normalized to 1 for each subspectrum of the source   
                                                                        
        do i=0,nSC 
         ni=iput+2*i 
         sTr(i)=aimag(array_fr(ni+1)) 
         sTr(-i)=aimag(array_fr(ni+2)) 
        end do 
                                                                        
        hr=0. 
        do n=-nSC+1,nSC-1,2 
         hr=hr+ sTr(n)*2 
        end do 
        do n=-nSC+2,nSC-2,2 
         hr=hr+sTr(n) 
        end do 
        hr=hr*2.+ sTr(-nSC)+sTr(nSC); hr=hr/3
!      Normierung: 2/(Gamma*pi)*srw*hr=1

        do n=0,nSC 
         ni=iput+2*n 
         array_fr(ni+1)=cmplx(real(array_fr(ni+1)),sTr(n))/hr 
         array_fr(ni+2)=cmplx(real(array_fr(ni+2)),sTr(-n))/hr  
        end do 

        deallocate(cLG,sTr)
!---------------------------- absorber ------------------------------ 
    case(2)

       allocate(cLG(-nAS:nAS))

        do n=iput+1,iput+(nAS+1)*2 
         array_fr(n)=0. 
        end do 
        srw=srw8*float(nst) 
        do i=1,jge 
         if(rtr(i).gt.1.e-5) then 
          call aLORGAU(Eagd(i),gamnat,e_xsi,                            &
                       srw,w_Lorentz(i),w_Gauss(i),iflag_Voigt,nAS,cLG)     
          hti=rtr(i)/2.0
!          hsum=(0.,0.)                                                       
          do n=0,nAS 
           ni=iput+2*n 
           hc=conjg(cLG(n)) 
!           hsum=hsum+hc
           array_fr(ni+1)=array_fr(ni+1)-hc*hti 
           hc=conjg(cLG(-n)) 
!           hsum=hsum+hc
           array_fr(ni+2)=array_fr(ni+2)-hc*hti 
          end do       ! n loop
         end if
        end do        ! i=1,jge
!       write(6,'(a,2i6)') ' th_11ref - absorber, iput,nAS=',iput,nAS   
!       write(6,'(4f15.6)') (rtr(i),i=1,jge)                            
!       write(6,'(6f12.6)') (aimag(array_fr(iput+i)),i=0,12)            
        deallocate(cLG) 
!---------------------------- detector ----------------------------------
    case(3)
       allocate(cLG(-nSC:nSC))

        do n=iput+1,iput+(nSC+1) 
         array_fr(n)=(0.,0.) 
        end do 
        do i=1,jge 
         call aLORGAU(Eagd(i),gamnat,e_xsi,                             &
                       srw8,w_Lorentz(i),w_Gauss(i),iflag_Voigt,nSC,cLG)   
         do n=0,nSC 
          ni=iput+n+1 
          array_fr(ni)=array_fr(ni)+                                    &
          cmplx(aimag(cLG(n)),aimag(cLG(-n)))*rtr(i)                   
         end do ! n loop
        end do  ! i=1,jge
       deallocate(cLG)
    end select                                                            
   return 
   END                                           
                                                                        
                                                                     
     subroutine th_22indexsad(isubthe,icase,iput,iget,info) 
!    sad= source,absorber,detector : lstr1case=1,2,3 (comthe.for)      
     use glbconst, only: maxfr1,maxfr2,maxthss,maxscrd,icstrf,ivstrf,   &
                         enwr,nwr
     use comthe, only: array_fr,theoryname,mLG,ifrcase,lstr1case
     implicit none 
     integer, intent(inout):: isubthe   
     integer, intent(in)   :: icase,iput,iget
     integer, intent(out)  :: info      
                                                                       
      integer,parameter::istr=38+4*(maxfr1+maxfr2)+3*maxthss 
      integer       dstr,iposLG,iadd                                          
      common/struct/dstr(istr+1),iposLG,iadd(6)

      integer       ibe,jpolsource,jpolabsorber,iflag_basis,idum,    &
                    nLG,nAS,nSC,idum2,ak8,sk8,ien
      real          srw8 
      common/strLOC/jpolsource,jpolabsorber,ibe(10),iflag_basis,     &
                    idum,nLG,nAS,nSC,idum2,ak8,sk8,srw8,ien(11)      

     logical       b_vsp,b_v_max,b_dumvsp 
     common/bvstrf/b_vsp(4),b_v_max,b_dumvsp(ivstrf-5) 
                                                                       
!    storage use nst2_8 for 4 complex numbers of r_ik                  
     real          c1,gamnat,e_xsi,flag_SAMP,flag_Voigt,offset,dumc 
     common/acmaps/c1,gamnat,e_xsi,flag_SAMP,flag_Voigt,offset,dumc(icstrf-6) 
     real          avm,sftr,aisom,w_Gauss,wLorentz,dumv 
     logical       b_vm,b_sftr,b_isom,b_w_Gauss,b_wLorentz,b_dumv 
     common/avmaps/avm,sftr,aisom,w_Gauss,wLorentz(8),dumv(ivstrf-12) 
     common/bvmaps/b_vm,b_sftr,b_isom,b_w_Gauss,b_wLorentz(8),           &
                   b_dumv(ivstrf-12)                                    
                                                                       
                                                                       
     logical   b_pc,b_polisp,bxx 
     integer   nE,iflag_SAMP,iflag_Voigt,ioffset,ige,jge,lge,jn,ip,      &
               i,j,k,k1,k2,l,n,ni,nd,nn,nget,nall,n_all,nst      
     real      Eagd,hr,hi,hti,sqrt2,satrace_r,satrace_i,w_Lorentz,       &
               azz,d_x2,aszz,dsx2,fd,srw,ppmm,pp_mm,fs,sl_t,sl_s,htis
                 
     complex   hrtr,hrpm,ctr,cpm,cmp,hc,hci,trcp,ofcp

     complex,dimension(2,2)::trv,TSPCA,sph 
     real,    dimension(:), allocatable :: sTr,tint 
     complex, dimension(:), allocatable :: trint,ofint
     complex, dimension(:), allocatable :: cLG

     character(len=8) :: ch8
                                                                  
      if(isubthe.lt.0) then 
       theoryname='2x2_ref_index_static_sad    v=101' 
       if(ifrcase.le.4.or.ifrcase.eq.6) then 
        i=2 
        if(jpolsource.eq.1) i=4 
        if(-isubthe.eq.1) then 
         c1=i*(nSC+1)+1 
        end if 
        if(-isubthe.eq.2) then 
         c1=2*(nAS+1) 
         if(jpolabsorber.eq.1)c1=c1*4 
        end if 
        if(-isubthe.eq.3) c1=i*(nSC+1) 
       end if 
       if(ifrcase.eq.5) then 
        c1=2*(nAS+1) 
        if(jpolabsorber.eq.1) c1=c1*4 
       end if
       return 
      end if 
!       write(6,'(a,6f10.2)')'th_22refindexf avm,sftr,aisom,w_Gauss,w_Lorentz=',&            
!                      avm,sftr,aisom,w_Gauss,w_Lorentz               
                                                                        
      hci=cmplx(0.,1.) 
      iflag_SAMP=flag_SAMP 
      iflag_Voigt=flag_Voigt 
                                                                        
                                                                        
      nst=4 
                                                                        
      call get_theory(isubthe,info) 
      if(info.gt.0) return 
!       write(6,'(a,5f10.4,/,50x,5l5)')                                 
!     &  'th_22refindexf avm,sftr,aisom,w_Gauss,w_Lorentz=',            
!     &                  avm,sftr,aisom,w_Gauss,w_Lorentz,              
!     &             b_vm,b_sftr,b_isom,b_w_Gauss,b_w_Lorentz            
                                                                        
      b_pc=b_v_max.or.b_isom.or.b_w_Gauss.or.isubthe.gt.0 
      do i=1,8
       b_pc=b_pc.or.b_wLorentz(i)
      end do
      if(.not.b_pc.or.info.gt.0) then 
       isubthe=-abs(isubthe) 
       goto 400 
      else 
        isubthe=abs(isubthe) 
      end if 
                                                                        
      nget=real(array_fr(iget+1)) 
      n_all=real(array_fr(nget+1)) 
      jge=aimag(array_fr(nget+1)) 
      bxx=real(array_fr(nget+2)).gt.0.01 
                                                                        
                                                                        
       if (iflag_basis.eq.-1) then 
       sqrt2=1./sqrt(2.) 
       TSPCA(1,1)=cmplx( sqrt2,0.) 
       TSPCA(1,2)=cmplx(-sqrt2,0.) 
       TSPCA(2,1)=cmplx(0.,-sqrt2) 
       TSPCA(2,2)=cmplx(0.,-sqrt2) 
!      transformation matrix from spherical basis to (sigma,pi)-basis   
       do nall=1,n_all 
        ip=nget+2+3*jge*(nall-1) 
        do jn=ip,ip+jge*3-2,3 
         pp_mm=real(array_fr(jn+2)) 
         ppmm =aimag(array_fr(jn+2)) 
                                                                        
         sph(1,1)= pp_mm+ppmm 
         sph(2,2)=-pp_mm+ppmm 
         sph(1,2)= array_fr(jn+3) 
         sph(2,1)= conjg(sph(1,2)) 
                                                                        
         do i=1,2 
         do k=1,2 
          hc=cmplx(0.,0.) 
          do j=1,2 
          do l=1,2 
           hc=hc+TSPCA(i,l)*sph(l,j)*conjg(TSPCA(k,j)) 
          end do 
          end do 
          trv(i,k)=hc 
         end do 
         end do 
         array_fr(jn+2)=cmplx(real(trv(1,1)-trv(2,2)),                  &
     &                  real(trv(1,1)+trv(2,2)))/2.                     
         array_fr(jn+3)=trv(1,2) 
        end do  ! jn= 
       end do   ! nall=1,n_all    
      end if 

      ioffset=offset 
!      write(6,'(a,5i8)')&
!      '  2x2_ref_index_static_f iget,nget,iput,lstr1case,ioffset=', &    
!              iget,nget,iput,lstr1case,ioffset                           
                                                                        
      goto (100,200,300),lstr1case 
!---------------------- source ------------------------------------     
  100 continue 
!      write(6,'(a,L5)') 'jpolsource=',jpolsource 
      ioffset=offset
      b_polisp=jpolsource.eq.1
      fs=0.
      do nall=1,n_all 
       ip=nget+2+3*jge*(nall-1) 
                                                                        
       if(enwr(7).eq.'fani') then 
        if(bxx) then 
         aszz=aimag(array_fr(ip+1)) 
         dsx2=aimag(array_fr(ip+4)) 
         azz =aimag(array_fr(ip+7)) 
         d_x2=aimag(array_fr(ip+10)) 
         fd=exp(-azz*d_x2-aszz*dsx2) 
        else 
         fd=exp(-aimag(array_fr(ip+13))) 
        end if 
        fs=fs+fd 
        write(nwr,'(a,i2,a2,f10.3)')                                    &
          'anisotropic part of the f-source(',nall,')=',fd             
       end if 
                                                                        
       do jn=ip+1,ip+jge*3-2,3 
        Eagd=real(array_fr(jn))+aisom 
        nE=ifix(Eagd/srw8+0.5)          ! nE <= sk8   
        if (abs(nE).gt.sk8) write(nwr,'(2(a,f10.2),a)')                 &
         '**** E(source)=',Eagd,' out of range ',sk8*srw8,'[mm/s]'     
       end do   ! jn=   
      end do   ! nall=1,n_all 
      if(enwr(7).eq.'fani') write(nwr,'(a,f10.3)')                      &
       'average over all sites and directions of f-source=',fs/n_all   
                                                                        
       i=2 
       if(b_polisp) i=4 
       do n=iput+1,iput+(nSC+1)*i 
        array_fr(n)=(0.,0.) 
       end do 
       w_Lorentz=wLorentz(1) 

      if(iflag_SAMP.eq.1) then 

       if(icase.eq.1)call LORGAU(gamnat,e_xsi,                          &
                          srw8,w_Lorentz,w_Gauss,iflag_Voigt,iposLG,nLG)  
                                                                        
!       write(6,'(a,i6,/,4f12.5)') &                                     
!       ' *source* iposLG,array_fr(iposLG,+1)=',                        
!       iposLG,array_fr(iposLG),array_fr(iposLG+1)                      
                                                                        
                                                                        
       if(b_polisp) then 
                                                                        
        do nall=1,n_all 
         ip=nget+2+3*jge*(nall-1) 
                                                                        
         if(bxx) then 
          aszz=aimag(array_fr(ip+1)) 
          dsx2=aimag(array_fr(ip+4)) 
          azz =aimag(array_fr(ip+7)) 
          d_x2=aimag(array_fr(ip+10)) 
          fd=exp(-azz*d_x2-aszz*dsx2) 
         else 
          fd=exp(-aimag(array_fr(ip+13))) 
         end if 

        ige=0
        lge=0 
        do jn=ip,ip+jge*3-3,3 
         ige=ige+1
         if(icase.eq.2) then
          if(ige.ge.ioffset)then
           lge=lge+1
           if(lge.le.8) then
            w_Lorentz=wLorentz(lge)
           else 
            w_Lorentz=wLorentz(1)
           end if
          end if
          call LORGAU(gamnat,e_xsi,                                       &
                       srw8,w_Lorentz,w_Gauss,iflag_Voigt,iposLG,nLG)        
         end if             

          nE=ifix((real(array_fr(jn+1))+aisom)/srw8+0.5) 
                                                                        
          hrtr=array_fr(jn+2)*fd 
          hrpm=array_fr(jn+3)*fd 
                                                                        
                                                                        
         do n=0,nSC 
          ni=iput+4*n 
                                                                        
          nd=abs(4*n-nE) 
          if(nd.le.nLG) then 
!          Sum;ab rpq(ab)/2*LG(E-Eab)  LG(E-Eab) on 1,3,...,2n+1        
           hi=aimag(array_fr(iposLG+nd)) 
           array_fr(ni+1)=array_fr(ni+1)+hi*hrtr 
           array_fr(ni+2)=array_fr(ni+2)+hi*hrpm 
          end if 
                                                                        
          nd=abs(-4*n-nE) 
          if(nd.le.nLG) then 
           hi=aimag(array_fr(iposLG+nd)) 
           array_fr(ni+3)=array_fr(ni+3)+hi*hrtr 
           array_fr(ni+4)=array_fr(ni+4)+hi*hrpm 
          end if 
         end do 
        end do ! jn=jge
       end do  ! n_all
       else 

        do nall=1,n_all 
         ip=nget+2+3*jge*(nall-1) 
                                                                        
         if(bxx) then 
          aszz=aimag(array_fr(ip+1)) 
          dsx2=aimag(array_fr(ip+4)) 
          azz =aimag(array_fr(ip+7)) 
          d_x2=aimag(array_fr(ip+10)) 
          fd=exp(-azz*d_x2-aszz*dsx2) 
         else 
          fd=exp(-aimag(array_fr(ip+13))) 
         end if 

         ige=0
         lge=0 
         do jn=ip,ip+jge*3-3,3 
          ige=ige+1
          if(icase.eq.2.and.ige.ge.ioffset)then
           lge=lge+1
           if(lge.le.8) then
            w_Lorentz=wLorentz(lge)
           else 
            w_Lorentz=wLorentz(1)
           end if
           call LORGAU(gamnat,e_xsi,                                       &
                        srw8,w_Lorentz,w_Gauss,iflag_Voigt,iposLG,nLG)        
          end if                       

          nE=ifix((real(array_fr(jn+1))+aisom)/srw8+0.5) 
          hrtr=array_fr(jn+2)*fd 
                                                                        
          do n=0,nSC 
           ni=iput+4*n 
                                                                        
           nd=abs(4*n-nE) 
           if(nd.le.nLG) then 
            array_fr(ni+1)=array_fr(ni+1)+hrtr*aimag(array_fr(iposLG+nd)) 
           end if 
           nd=abs(-4*n-nE) 
           if(nd.le.nLG) then 
            array_fr(ni+2)=array_fr(ni+2)+hrtr*aimag(array_fr(iposLG+nd)) 
           end if 
          end do 
         end do     ! jn
        end do      ! n_all
       end if 
      else   ! if(iflag_SAMP.eq.0) then
                                                                        
       allocate(tint(jge),trint(jge),ofint(jge),cLG(-nSC:nSC))
       srw=4.0*srw8 
                                                                        
       do nall=1,n_all 
        ip=nget+2+3*jge*(nall-1) 
        if(bxx) then 
         aszz=aimag(array_fr(ip+1)) 
         dsx2=aimag(array_fr(ip+4)) 
         azz =aimag(array_fr(ip+7)) 
         d_x2=aimag(array_fr(ip+10)) 
         fd=exp(-azz*d_x2-aszz*dsx2) 
        else 
         fd=exp(-aimag(array_fr(ip+13))) 
        end if 
        ige=0
        lge=0


        if(enwr(7)(1:2).eq.'sl') then
         sl_t=0.
         do jn=ip,ip+jge*3-3,3 
          sl_t=sl_t+aimag(array_fr(jn+2))*fd 
         end do
         ch8=enwr(7)(3:4) 
         call c8toi(ch8,i) 
         k1=(i-1)*3; k2=i*3 -jge*3
        else
         k1=0; k2=0
        end if
        sl_s=0.0
        do jn=ip+k1,ip+k2+jge*3-3,3 
         ige=ige+1
         if(icase.eq.2) then
          if(ige.ge.ioffset)then
           lge=lge+1
           if(lge.le.8) then
            w_Lorentz=wLorentz(lge)
           else 
            w_Lorentz=wLorentz(1)
           end if
          end if
          call aLORGAU(real(array_fr(jn+1))+aisom,gamnat,e_xsi,          &
                            srw,w_Lorentz,w_Gauss,iflag_Voigt,nSC,cLG)     
         else
          call aLORGAU(real(array_fr(jn+1))+aisom,gamnat,e_xsi,          &
                            srw,w_Lorentz,w_Gauss,iflag_Voigt,nSC,cLG)     
         end if 
              
         hrtr=array_fr(jn+2)*fd 
         hrpm=array_fr(jn+3)*fd 
         trint(ige)=array_fr(jn+2); ofint(ige)=array_fr(jn+3)
!         trint(ige)=hrtr; ofint(ige)=hrpm
                                                                      
         hti= aimag(hrtr)/2.0 
         ctr= real(hrtr)*hci/2.0 
         cpm= hrpm*hci/2.0 
         cmp= conjg(hrpm)*hci/2.0 
         sl_s=sl_s+aimag(array_fr(jn+2))*fd 
!         if(ige.ne.4.and.ige.ne.5) then
!          hrtr=(0.,0.); hrpm=(0.,0.)
!         end if                                                               
         Eagd=real(array_fr(jn+1))+aisom                               
!         nE=ifix(Eagd/srw8+0.5)                                        
!        if(abs(Eagd).gt.4.9) then  
!         write(nwr,'(i8,a,8f10.2)')ige,' Esource=',Eagd,hrtr*100,hrpm*100 
                                                                      
         if(b_polisp) then 
          do n=0,nSC 
           nn=iput+4*n 
           array_fr(nn+1)=array_fr(nn+1)+ aimag(cLG(n ))*hrtr 
           array_fr(nn+2)=array_fr(nn+2)+ aimag(cLG(n ))*hrpm 
           array_fr(nn+3)=array_fr(nn+3)+ aimag(cLG(-n))*hrtr 
           array_fr(nn+4)=array_fr(nn+4)+ aimag(cLG(-n))*hrpm 
          end do 
         else 
          do n=0,nSC 
           nn=iput+2*n 
           array_fr(nn+1)=array_fr(nn+1)+ aimag(cLG(n ))*hrtr 
           array_fr(nn+2)=array_fr(nn+2)+ aimag(cLG(-n))*hrtr 
          end do 
         end if
!       end if 
        end do       ! jn=
       if(enwr(7).eq.'rhom')then
        print '(a,i5)','(r11-r22,r11+r22) (1:4) source site=',n_all
        print '(4(3x,2f10.5))',(trint(i),i=1,4)
        print '(a,i5)','(r12)(1:4):'
        print '(4(3x,2f10.5))',(ofint(i),i=1,4)
       end if
      end do         ! n_all
      deallocate(tint,trint,ofint,cLG)
      end if         ! iflag_SAMP 
                                                                        
!     The sum of the Lorentz-Gauss curves of the jge lines              
!     have to be normalized to 1 for each subspectrum of the source     
!     iscpi=iscpr+2*nSC+1                                               
                                                                        
!     write(6,'(a,i5,5x,2f15.8)')                                       
!    &           ' isc3,sTr(0)=',isc3,array_fr(isc3+1)  
        allocate(sTr(-nSC:nSC))
                
        if(b_polisp) then 
         do i=0,nSC 
          nn=iput+4*i 
          sTr(i)=aimag(array_fr(nn+1)) 
          sTr(-i)=aimag(array_fr(nn+3)) 
         end do 
        else 
         do i=0,nSC 
          nn=iput+2*i 
          sTr(i)=aimag(array_fr(nn+1)) 
          sTr(-i)=aimag(array_fr(nn+2)) 
         end do 
        end if 
!         write(6,'(a,i4,a,2f15.5)') (' i=',i,'sTr(+-i)=',              
!     &    sTr(i),sTr(-i),i=0,5)                                        
                                                                        
         hr=0. 
         do n=-nSC+1,nSC-1,2 
          hr=hr+ sTr(n)*2 
         end do 
         do n=-nSC+2,nSC-2,2 
          hr=hr+sTr(n) 
         end do 
         hr=hr*2.+ sTr(-nSC)+sTr(nSC); hr=hr/3. 

        if(b_polisp) then 
         do i=0,nSC 
          nn=iput+4*i 
          array_fr(nn+1)=cmplx(real(array_fr(nn+1)),sTr(i))/hr 
          array_fr(nn+2)=array_fr(nn+2)/hr
          array_fr(nn+3)=cmplx(real(array_fr(nn+3)),sTr(-i))/hr 
          array_fr(nn+4)=array_fr(nn+4)/hr      
         end do 
        else 
         do i=0,nSC 
          nn=iput+2*i 
          array_fr(nn+1)=cmplx(real(array_fr(nn+1)),sTr(i))/hr 
          array_fr(nn+2)=cmplx(real(array_fr(nn+2)),sTr(-i))/hr  
         end do 
        end if 

        if(enwr(7)(1:2).eq.'sl'.and.sl_t.gt.0.) hr=hr*sl_t/sl_s
        deallocate(sTr)
       goto 400 
!------------------------ absorber ----------------------------------   
  200  continue 
!    write(6,'(a,5i6)') '2x2_ref n_all,icase,iflag_SAMP=',n_all,icase,iflag_SAMP                     
!    write(6,'(a,L5)') 'jpolabsorber=',jpolabsorber

     b_polisp=jpolabsorber.eq.1    
     fs=0. 
     do nall=1,n_all 
      ip=nget+2+3*jge*(nall-1) 
                                                                      
      if(enwr(7).eq.'fani') then 
       if(bxx) then 
        aszz=aimag(array_fr(ip+1)) 
        dsx2=aimag(array_fr(ip+4)) 
        azz =aimag(array_fr(ip+7)) 
        d_x2=aimag(array_fr(ip+10)) 
        fd=exp(-azz*d_x2-aszz*dsx2) 
!        fd=1.-azz*d_x2-aszz*dsx2                                       
       else 
        fd=exp(-aimag(array_fr(ip+13))) 
!        fd=1.-aimag(array_fr(ip+13))                                   
       end if 
       fs=fs+fd 
       write(nwr,'(a,i2,a2,f10.3)')                                   &
        'anisotropic part of the f-absorber(',nall,')=',fd           
      end if 
                                                                      
      do jn=ip+1,ip+jge*3-2,3 
       Eagd=real(array_fr(jn))+aisom 
       nE=ifix(Eagd/srw8+0.5)          ! nE <= sk8 
      if (abs(nE).gt.ak8) write(nwr,'(2(a,f10.4),a)')                 &
       '**** E(absorber)=',Eagd,' out of range ',ak8*srw8,'[mm/s]'   
      end do  ! jn=  
     end do   !  nall=1,n_all  
     if(enwr(7).eq.'fani') write(nwr,'(a,f10.3)')                     &
     'average over all sites and directions of f-absorber=',fs/n_all 
                                                                      
      i=2 
      if(jpolabsorber.eq.1) i=8 
      do n=iput+1,iput+(nAS+1)*i 
       array_fr(n)=(0.,0.) 
      end do 

     w_Lorentz=wLorentz(1) 
     if(iflag_SAMP.eq.1) then 
                                                                      
      if(icase.eq.1) call LORGAU(gamnat,e_xsi,                       &
                          srw8,w_Lorentz,w_Gauss,iflag_Voigt,iposLG,nLG)
!     write(6,'(2a,/,5f10.4,5i8)')'gamnat,e_xsi,',                    
!     'srw8,w_Lorentz,w_Gauss,nLG,iflag_Voigt,iposLG=',          
!     gamnat,e_xsi,srw8*1000,w_Lorentz,w_Gauss,                       
!     nLG,iflag_Voigt,iposLG                                     
                                                                      
     if(b_polisp) then 
                                                                    
      do nall=1,n_all 
       ip=nget+2+3*jge*(nall-1) 
                                                                      
       if(bxx) then 
        aszz=aimag(array_fr(ip+1)) 
        dsx2=aimag(array_fr(ip+4)) 
        azz =aimag(array_fr(ip+7)) 
        d_x2=aimag(array_fr(ip+10)) 
         fd=exp(-azz*d_x2-aszz*dsx2) 
!         fd=1.-azz*d_x2-aszz*dsx2 
        else 
         fd=exp(-aimag(array_fr(ip+13))) 
!         fd=1.-aimag(array_fr(ip+13))
       end if
 
!       write(6,'(a,f10.4)')' fd=',fd                                                               

       ige=0
       lge=0  
       do jn=ip,ip+jge*3-3,3 
        ige=ige+1
        if(icase.eq.2) then
         if(ige.ge.ioffset)then
          lge=lge+1
          if(lge.le.8) then
           w_Lorentz=wLorentz(lge)
          else 
           w_Lorentz=wLorentz(1)
          end if
         end if
         call LORGAU(gamnat,e_xsi,srw8,w_Lorentz,w_Gauss,iflag_Voigt,iposLG,nLG)
        end if
        hrtr=array_fr(jn+2)*fd 
        hrpm=array_fr(jn+3)*fd 
                                                                      
!       Poincare decomposition of rho (mossbauer)                 
        hti= aimag(hrtr)/2.0 
        ctr= real(hrtr)*hci/2.0 
        cpm= hrpm*hci/2.0 
        cmp= conjg(hrpm)*hci/2.0 
                                                            
!       nkz=kz*I-Sum;ab rpq(ab)/2*(-i+(E-Eab)/hga)*LG(E-Eab)          
!       nkz=kz*I-Sum;ab rpq(ab)/2*(-i*LGi(E-Eab)+LGr(E-Eab))          
!       b1=1/2 kz*(npm+nmp)                                           
!       b2=1/2 kz*(npm-nmp)*i                                         
!       b3=1/2 kz*(npp-nmm)                                           
!       the factor 1/4 is the factor in 1/2 kz*(...) and in npq ( 1/2r
!       fLG=(4*n-nE)*srw8/(hga/2.) is written as                      
                                                                      
        Eagd=real(array_fr(jn+1))+aisom 
        nE=ifix(Eagd/srw8+0.5) 
!       write(6,'(2i8,a,8f10.4)')ip,lge,' E,p=',Eagd,w_Lorentz,w_Gauss         
                                                                      
        do n=0,nAS 
         ni=iput+8*n 
         nd=nst*n-nE                 ! +n                            
         if(abs(nd).le.nLG) then 
          if(nd.gt.0) then 
           hc=conjg(array_fr(iposLG+nd)) 
          else 
           hc=-array_fr(iposLG-nd) 
          end if 
          array_fr(ni+1)=array_fr(ni+1)-hc*hti 
          array_fr(ni+2)=array_fr(ni+2)-hc*ctr 
          array_fr(ni+3)=array_fr(ni+3)-hc*cpm 
          array_fr(ni+4)=array_fr(ni+4)-hc*cmp 
         end if 
         nd=-nst*n-nE                   ! -n 
         if(abs(nd).le.nLG) then 
          if(nd.gt.0) then 
           hc=conjg(array_fr(iposLG+nd)) 
          else 
           hc=-array_fr(iposLG-nd) 
          end if 
          array_fr(ni+5)=array_fr(ni+5)-hc*hti 
          array_fr(ni+6)=array_fr(ni+6)-hc*ctr 
          array_fr(ni+7)=array_fr(ni+7)-hc*cpm 
          array_fr(ni+8)=array_fr(ni+8)-hc*cmp 
         end if 
        end do      ! nAS 
       end do       ! jn=  
      end do        ! n_all 
     else           ! if .not.polarized 
                                                                      
      do nall=1,n_all 
       ip=nget+2+3*jge*(nall-1) 
                                                                      
       if(bxx) then 
        aszz=aimag(array_fr(ip+1)) 
        dsx2=aimag(array_fr(ip+4)) 
        azz =aimag(array_fr(ip+7)) 
        d_x2=aimag(array_fr(ip+10)) 
         fd=exp(-azz*d_x2-aszz*dsx2) 
!         fd=1.-azz*d_x2-aszz*dsx2 
        else 
         fd=exp(-aimag(array_fr(ip+13))) 
!         fd=1.-aimag(array_fr(ip+13))
        end if
       ige=0
       lge=0                                                                          
       do jn=ip,ip+jge*3-3,3 
        ige=ige+1
        if(icase.eq.2) then
         if(ige.ge.ioffset)then
          lge=lge+1
          if(lge.le.8) then
           w_Lorentz=wLorentz(lge)
          else 
           w_Lorentz=wLorentz(1)
          end if
         end if
         call LORGAU(gamnat,e_xsi,srw8,w_Lorentz,w_Gauss,iflag_Voigt,iposLG,nLG)
        end if

        hrtr=array_fr(jn+2)*fd 
        hti = aimag(hrtr)/2.0 
                                                                      
        Eagd=real(array_fr(jn))+aisom 
        nE=ifix(Eagd/srw8+0.5) 
                                                                      
        do n=0,nAS 
         ni=iput+8*n 
         nd=nst*n-nE                  ! +n
         if(abs(nd).le.nLG) then 
          if(nd.gt.0) then 
           hc=conjg(array_fr(iposLG+nd)) 
          else 
           hc=-array_fr(iposLG-nd) 
          end if 
          array_fr(ni+1)=array_fr(ni+1)-hc*hti 
!         if(n.lt.5) write(6,'(3i6,8f9.4)')iposLG,nd,nE,hc*100.,hti   
         end if 
         nd=-nst*n-nE                  ! -n 
         if(abs(nd).le.nLG) then 
          if(nd.gt.0) then 
           hc=conjg(array_fr(iposLG+nd)) 
          else 
           hc=-array_fr(iposLG-nd) 
          end if 
          array_fr(ni+2)=array_fr(ni+2)-hc*hti 
         end if 
        end do      ! nAS 
       end do       ! jn= 
      end do        ! n_all 
     end if         ! polarized 
                                                                      
    else     !flag sampling 
!    iflag_SAMP=0  

     allocate(cLG(-nAS:nAS))

     srw=srw8*float(nst) 
     hi=0.0; hr=0.0 
     trcp=(0.,0.)
     ofcp=(0.,0.)
     allocate(tint(jge),trint(jge),ofint(jge))
      
    do nall=1,n_all 
      ip=nget+2+3*jge*(nall-1) 
                                                                      
      if(bxx) then 
       aszz=aimag(array_fr(ip+1)) 
       dsx2=aimag(array_fr(ip+4)) 
       azz =aimag(array_fr(ip+7)) 
       d_x2=aimag(array_fr(ip+10)) 
       fd=exp(-azz*d_x2-aszz*dsx2) 
!       fd=1.-azz*d_x2-aszz*dsx2 
      else 
       fd=exp(-aimag(array_fr(ip+13))) 
!       fd=1.-aimag(array_fr(ip+13)) 
      end if 

      ige=0
      lge=0 
      htis=0.
      do jn=ip,ip+jge*3-3,3 
       ige=ige+1
       if(icase.eq.2) then
         if(ige.ge.ioffset)then
          lge=lge+1
          if(lge.le.8) then
           w_Lorentz=wLorentz(lge)
          else 
           w_Lorentz=wLorentz(1)
          end if
         end if
        call aLORGAU(real(array_fr(jn+1))+aisom,gamnat,e_xsi,          &
                          srw,w_Lorentz,w_Gauss,iflag_Voigt,nAS,cLG)     
       else
        call aLORGAU(real(array_fr(jn+1))+aisom,gamnat,e_xsi,          &
                          srw,w_Lorentz,w_Gauss,iflag_Voigt,nAS,cLG)     
       end if        
!      write(6,'(6f10.2)') real(array_fr(jn+1)),array_fr(jn+2)*100.,array_fr(jn+3)*100.
       hrtr=array_fr(jn+2)*fd 
       hrpm=array_fr(jn+3)*fd 
       trint(ige)=array_fr(jn+2)*fd; ofint(ige)=array_fr(jn+3)*fd
                                                                     
       hti= aimag(hrtr)/2.0 
       ctr= real(hrtr)*hci/2.0 
       cpm= hrpm*hci/2.0 
       cmp= conjg(hrpm)*hci/2.0 
!      switch off off diagonal elements and polarization
!      cpm=(0.0); cpm=(0.0); ctr=(0.,0.);htis=htis+hti/fd
!      print*,'hrtr,fd=',hrtr,fd
       tint(ige)=hti+real(hrtr)/2.0
!       tint(ige)=hti

!       write(6,'(2a,/,5f10.4,5i8)')'gamnat,e_xsi,',                  
!   &   'srw8,w_Lorentz,w_Gauss,nLG,iflag_Voigt,iposLG=',        
!   &    gamnat,e_xsi,srw*250,w_Lorentz,w_Gauss,nAS,iflag_Voigt       
                                                          
       if(b_polisp) then 
        do n=0,nAS 
         ni=iput+8*n 
         hc=conjg(cLG(n)) 
         array_fr(ni+1)=array_fr(ni+1)-hc*hti 
         array_fr(ni+2)=array_fr(ni+2)-hc*ctr 
         array_fr(ni+3)=array_fr(ni+3)-hc*cpm 
         array_fr(ni+4)=array_fr(ni+4)-hc*cmp 
         hc=conjg(cLG(-n)) 
         array_fr(ni+5)=array_fr(ni+5)-hc*hti 
         array_fr(ni+6)=array_fr(ni+6)-hc*ctr 
         array_fr(ni+7)=array_fr(ni+7)-hc*cpm 
         array_fr(ni+8)=array_fr(ni+8)-hc*cmp 
        end do 
       else 
        do n=0,nAS 
         ni=iput+2*n 
         hc=conjg(cLG(n)) 
         array_fr(ni+1)=array_fr(ni+1)-hc*hti 
         hc=conjg(cLG(-n)) 
         array_fr(ni+2)=array_fr(ni+2)-hc*hti 
        end do 
       end if 
      end do       !   jn=


      hi=hi+tint(1)+tint(2)+tint(3)+tint(4) 
      hr=hr+tint(5)+tint(6)+tint(7)+tint(8) 
!      trcp=trcp+trint(1)+trint(2)+trint(3)+trint(4) 
!      ofcp=ofcp+ofint(1)+ofint(2)+ofint(3)+ofint(4) 
      trcp=trcp+trint(5)+trint(6)+trint(7)+trint(8) 
      ofcp=ofcp+ofint(5)+ofint(6)+ofint(7)+ofint(8) 
     end do        ! nall=1,n_all 
    if(enwr(7).eq.'intr')print '(8f12.5)',hi,hr, (hi+hr),hi/(hr+hi),1.0/(hr+hi) 
    if(enwr(7).eq.'rhom')then
     print '(a)','(r11-r22,r11+r22) sum(5-8), offdia sum(5-8), pol'
     hr=sqrt(ofcp*conjg(ofcp))/aimag(trcp)
     print '(2(4x,2f12.5),4x,f10.3)',trcp,ofcp,hr
    end if 
    deallocate(tint,trint,ofint,cLG)
    end if         ! iflag_SAMP 
    goto 400 
                                                                      
!------------------------------detector-----------------------------------   
  300  continue 
      n_all=real(array_fr(nget+1)) 
      jge=real(array_fr(nget+2)) 
      bxx=aimag(array_fr(nget+2)).gt.0.01 
                                                                        
                                                                        
       do n=iput+1,iput+(nSC+1) 
        array_fr(n)=(0.,0.) 
       end do 
                                                                        
      if(iflag_SAMP.eq.1) then 
                                                                        
       do nall=1,n_all 
        ip=nget+2+3*jge*(nall-1) 
        do jn=ip+1,ip+jge*3-2,3 
         Eagd=real(array_fr(jn))+aisom 
                                         ! nE <= sk8                    
         nE=ifix(Eagd/srw8+0.5) 
         if (abs(nE).gt.sk8) write(nwr,'(2(a,f10.2),a)')                &
         '**** E(detector)=',Eagd,' out of range ',sk8*srw8,'[mm/s]'   
        end do  ! jn=   
       end do   ! nall=1,n_al
                                                                        
       call LORGAU(gamnat,e_xsi,                                       &
                    srw8,w_Lorentz,w_Gauss,iflag_Voigt,iposLG,nLG)           
                                                                        
!      write(6,'(a,i6,/,4f12.5)')                                       
!    &  ' *detector* iposLG,array_fr(iposLG,+1)=',                      
!    &  iposLG,array_fr(iposLG),array_fr(iposLG+1)                      
                                                                        
                                                                        
        do nall=1,n_all 
         ip=nget+2+3*jge*(nall-1) 
                                                                        
         if(bxx) then 
          aszz=aimag(array_fr(ip+1)) 
          dsx2=aimag(array_fr(ip+4)) 
          azz =aimag(array_fr(ip+7)) 
          d_x2=aimag(array_fr(ip+10)) 
          fd=exp(-azz*d_x2-aszz*dsx2) 
         else 
          fd=exp(-aimag(array_fr(ip+13))) 
         end if 
                                                                        
         do jn=ip,ip+jge*3-3,3 
          nE=ifix((real(array_fr(jn+1))+aisom)/srw8+0.5) 
                                                                        
                                                                        
          hrtr=array_fr(jn+2)*fd 
!         Sum;ab rpq(ab)/2*LG(E-Eab)                                    
                                                                        
          do n=0,nSC 
           ni=iput+n+1 
                                                                        
           nd=abs(4*n-nE) 
           if(nd.le.nLG)                                                &
           satrace_r=aimag(array_fr(iposLG+nd))*aimag(hrtr)             
           nd=abs(-4*n-nE) 
           if(nd.le.nLG)                                                &
           satrace_i=aimag(array_fr(iposLG+nd))*aimag(hrtr)             
           array_fr(ni)=array_fr(ni)+cmplx(satrace_r,satrace_i) 
          end do 
         end do     ! jn=  
        end do      ! nall=1,n_all
      else          ! if(iflag_SAMP.eq.1) then 
!      iflag_SAMP=0  

       allocate(cLG(-nSC:nSC))                                                                        
                                                                        
       do nall=1,n_all 
        ip=nget+2+3*jge*(nall-1) 
                                                                        
        if(bxx) then 
         aszz=aimag(array_fr(ip+1)) 
         dsx2=aimag(array_fr(ip+4)) 
         azz =aimag(array_fr(ip+7)) 
         d_x2=aimag(array_fr(ip+10)) 
         fd=exp(-azz*d_x2-aszz*dsx2) 
        else 
         fd=exp(-aimag(array_fr(ip+13))) 
        end if 
                                                                        
        do jn=ip,ip+jge*3-3,3 
         hrtr=array_fr(jn+2)*fd 
         call aLORGAU(real(array_fr(jn+1))+aisom,gamnat,e_xsi,          &
                      srw8,w_Lorentz,w_Gauss,iflag_Voigt,nSC,cLG)  
         do n=0,nSC 
          ni=iput+n+1 
          array_fr(ni)=array_fr(ni)+                                    &
           cmplx(aimag(cLG(n)),aimag(cLG(-n)))*aimag(hrtr)              
         end do    ! n 
        end do     ! jn=  
       end do      !  nall=1,n_all  
       deallocate(cLG)
      end if       ! iflag_SAMP 
                                                                        
  400 return 
      END                                           


     subroutine th_22indexsource(isubthe,icase,iput,iget,info) 
!    sad= source,absorber,detector : lstr1case=1,2,3 (comthe.for)      
     use glbconst, only: maxfr1,maxfr2,maxthss,maxscrd,icstrf,ivstrf,   &
                         enwr,nwr
     use comthe, only: array_fr,theoryname,mLG,ifrcase,lstr1case
     implicit none 
     integer, intent(inout):: isubthe   
     integer, intent(in)   :: icase,iput,iget
     integer, intent(out)  :: info      
                                                                       
      integer,parameter::istr=38+4*(maxfr1+maxfr2)+3*maxthss 
      integer       dstr,iposLG,iadd                                          
      common/struct/dstr(istr+1),iposLG,iadd(6)

      integer       ibe,jpolsource,jpolabsorber,iflag_basis,idum,    &
                    nLG,nAS,nSC,idum2,ak8,sk8,ien
      real          srw8 
      common/strLOC/jpolsource,jpolabsorber,ibe(10),iflag_basis,     &
                    idum,nLG,nAS,nSC,idum2,ak8,sk8,srw8,ien(11)      

     logical       b_vsp,b_v_max,b_dumvsp 
     common/bvstrf/b_vsp(4),b_v_max,b_dumvsp(ivstrf-5) 
                                                                       
!    storage use nst2_8 for 4 complex numbers of r_ik                  
     real          c1,gamnat,e_xsi,flag_SAMP,flag_Voigt,offset,dumc 
     common/acmaps/c1,gamnat,e_xsi,flag_SAMP,flag_Voigt,offset,dumc(icstrf-6) 
     real          avm,sftr,aisom,strength,wGauss,wLorentz,dumv 
     logical       b_vm,b_sftr,b_isom,b_strength,b_wGauss,b_wLorentz,b_dumv 
     common/avmaps/avm,sftr,aisom,strength(8),wGauss(8),wLorentz(8),   &
                   dumv(ivstrf-27)
     common/bvmaps/b_vm,b_sftr,b_isom,b_strength(8),b_wGauss(8),b_wLorentz(8),&
                   b_dumv(ivstrf-27)                                    

!    mg/cm2xf  =strength(1), mu_electronic=strength(2)
!    diffprof_a=strength(3), diffprof_d=strength(4)
    
     logical   b_polisp,bxx 
     integer   nE,iflag_SAMP,iflag_Voigt,ioffset,ige,jge,lge,jn,ip,   &
               i,j,k,l,n,nn,nget,nall,n_all,nst     
     real      Eagd,hr,hti,sqrt2,w_Gauss,w_Lorentz,     &
               a_strength,azz,d_x2,aszz,dsx2,fd,srw,ppmm,pp_mm,fs

     complex   hrtr,hrpm,ctr,cpm,cmp,hc,hci
     complex, dimension(2,2):: trv,TSPCA,sph 

     real,    dimension(:), allocatable :: sTr
     complex, dimension(:), allocatable :: cLG
                                           

      if(isubthe.lt.0) then 
       theoryname='2x2_rho_matrix_source    v=101' 
        if(-isubthe.eq.1) then 
         c1=6*(2*nSC+1)+1 
        end if 
       return 
      end if 
                                                                        
      hci=cmplx(0.,1.) 
      iflag_SAMP=0
      iflag_Voigt=0
      nst=4 

      call get_theory(isubthe,info) 
      if(info.gt.0) return 
!       write(6,'(a,/,5f10.4,/,10x,25l3)')  &                               
!      'th_22refindexf avm,sftr,aisom,w_Gauss,w_Lorentz=', &            
!                      avm,sftr,aisom,w_Gauss,w_Lorentz,   &           
!                 b_vm,b_sftr,b_isom,b_wGauss,b_wLorentz            
                                                                        
!     since the case ifrcase=6 :Mossbauer transmission_vS(6)
!     accumulates (see mossbauer_tmre()
!                      do lstruct3=issa,isse
!                       if(ifrcase.eq.6)then
!                        ...
!                        end if
!                       end do                 )
!     the 2x2 density matrices each calculation has to start at zero 

      isubthe=abs(isubthe) 
                                                                        
      nget=real(array_fr(iget+1)) 
      n_all=real(array_fr(nget+1)) 
      jge=aimag(array_fr(nget+1)) 
      bxx=real(array_fr(nget+2)).gt.0.01 
                                                                        
                                                                        
       if (iflag_basis.eq.-1) then 
       sqrt2=1./sqrt(2.) 
       TSPCA(1,1)=cmplx( sqrt2,0.) 
       TSPCA(1,2)=cmplx(-sqrt2,0.) 
       TSPCA(2,1)=cmplx(0.,-sqrt2) 
       TSPCA(2,2)=cmplx(0.,-sqrt2) 
!      transformation matrix from spherical basis to (sigma,pi)-basis   
       do nall=1,n_all 
        ip=nget+2+3*jge*(nall-1) 
        do jn=ip,ip+jge*3-2,3 
         pp_mm=real(array_fr(jn+2)) 
         ppmm =aimag(array_fr(jn+2)) 
                                                                        
         sph(1,1)= pp_mm+ppmm 
         sph(2,2)=-pp_mm+ppmm 
         sph(1,2)= array_fr(jn+3) 
         sph(2,1)= conjg(sph(1,2)) 
                                                                        
         do i=1,2 
         do k=1,2 
          hc=cmplx(0.,0.) 
          do j=1,2 
          do l=1,2 
           hc=hc+TSPCA(i,l)*sph(l,j)*conjg(TSPCA(k,j)) 
          end do 
          end do 
          trv(i,k)=hc 
         end do 
         end do 
         array_fr(jn+2)=cmplx(real(trv(1,1)-trv(2,2)),                  &
     &                  real(trv(1,1)+trv(2,2)))/2.                     
         array_fr(jn+3)=trv(1,2) 
        end do  ! jn= 
       end do   ! nall=1,n_all    
      end if 

      ioffset=offset 
!      write(6,'(a,5i8)')&
!      '  2x2_ref_index_static_f iget,nget,iput,lstr1case,ioffset=', &    
!              iget,nget,iput,lstr1case,ioffset                           
                                                                        
      if(lstr1case.gt.1)then
       print'(a,i3)',' lstr1case=',lstr1case
       return
      end if
 
!---------------------- source ------------------------------------     
!      write(6,'(a,L5,i6)') 'jpolsource,iput=',jpolsource,iput
      ioffset=offset
      b_polisp=jpolsource.eq.1
      fs=0.
      do nall=1,n_all 
       ip=nget+2+3*jge*(nall-1) 
                                                                        
       if(enwr(7).eq.'fani') then 
        if(bxx) then 
         aszz=aimag(array_fr(ip+1)) 
         dsx2=aimag(array_fr(ip+4)) 
         azz =aimag(array_fr(ip+7)) 
         d_x2=aimag(array_fr(ip+10)) 
         fd=exp(-azz*d_x2-aszz*dsx2) 
        else 
         fd=exp(-aimag(array_fr(ip+13))) 
        end if 
        fs=fs+fd 
        write(nwr,'(a,i2,a2,f10.3)')                                    &
          'anisotropic part of the f-source(',nall,')=',fd             
       end if 
                                                                        
       do jn=ip+1,ip+jge*3-2,3 
        Eagd=real(array_fr(jn))+aisom 
        nE=ifix(Eagd/srw8+0.5)          ! nE <= sk8   
        if (abs(nE).gt.sk8) write(nwr,'(2(a,f10.2),a)')                 &
         '**** E(source)=',Eagd,' out of range ',sk8*srw8,'[mm/s]'     
       end do   ! jn=   
      end do   ! nall=1,n_all 
      if(enwr(7).eq.'fani') write(nwr,'(a,f10.3)')                      &
       'average over all sites and directions of f-source=',fs/n_all   
                                                                        
       do n=iput+1,iput+(2*nSC+1)*6 
        array_fr(n)=(0.,0.) 
       end do 
       w_Lorentz=wLorentz(1) 
       w_Gauss=wGauss(1) 
       a_strength=strength(1)

       allocate(cLG(-nSC:nSC),sTr(-nSC:nSC))

       srw=4.0*srw8 
       do nall=1,n_all 
        ip=nget+2+3*jge*(nall-1) 
        if(bxx) then 
         aszz=aimag(array_fr(ip+1)) 
         dsx2=aimag(array_fr(ip+4)) 
         azz =aimag(array_fr(ip+7)) 
         d_x2=aimag(array_fr(ip+10)) 
         fd=exp(-azz*d_x2-aszz*dsx2) 
        else 
         fd=exp(-aimag(array_fr(ip+13))) 
        end if 
        ige=0
        lge=0


        do jn=ip,ip+jge*3-3,3 
         ige=ige+1
         if(ige.ge.ioffset)then
          lge=lge+1
          if(icase.eq.1)then
           if(lge.le.8) then
            w_Lorentz=wLorentz(lge)
            w_Gauss=wGauss(lge)
            a_strength=strength(lge)
           else 
            w_Lorentz=wLorentz(1)
            w_Gauss=wGauss(1)
           end if
          else
           a_strength=strength(1)
           if(lge.le.8) then
            w_Lorentz=wLorentz(lge)
            w_Gauss=wGauss(lge)
           else 
            w_Gauss=wGauss(1)
            w_Lorentz=wLorentz(1)
           end if
          end if
         end if
         call aLORGAU(real(array_fr(jn+1))+aisom,gamnat,e_xsi,          &
                            srw,w_Lorentz,w_Gauss,iflag_Voigt,nSC,cLG)     

          hrtr=array_fr(jn+2)*fd*a_strength
          hrpm=array_fr(jn+3)*fd*a_strength
         if(icase.eq.1) then
          do n=-nSC,nSC 
           nn=iput+6*(n+nSC) 
           array_fr(nn+1)=array_fr(nn+1)+ aimag(cLG(n ))*hrtr 
           array_fr(nn+2)=array_fr(nn+2)+ aimag(cLG(n ))*hrpm 
          end do 

         else ! icase.ge.2

          hti= aimag(hrtr)/2.0 
          ctr= real(hrtr)*hci/2.0 
          cpm= hrpm*hci/2.0 
          cmp= conjg(hrpm)*hci/2.0 
!         Eagd=real(array_fr(jn+1))+aisom                               
!         write(nwr,'(i8,a,8f10.2)') &
!            ige,' Esource=',Eagd,hrtr*100,hrpm*100,a_strength 


          do n=-nSC,nSC 
           nn=iput+6*(n+nSC) 
           array_fr(nn+1)=array_fr(nn+1)+ aimag(cLG(n ))*hrtr 
           array_fr(nn+2)=array_fr(nn+2)+ aimag(cLG(n ))*hrpm 
           hc=conjg(cLG(n)) 
           array_fr(nn+3)=array_fr(nn+3)-hc*hti 
           array_fr(nn+4)=array_fr(nn+4)-hc*ctr 
           array_fr(nn+5)=array_fr(nn+5)-hc*cpm 
           array_fr(nn+6)=array_fr(nn+6)-hc*cmp 
          end do 
         end if      ! icase
        end do       ! jn=
       end do        ! n_all

                                                                        
!     The sum of the Lorentz-Gauss curves of the jge lines              
!     have to be normalized to 1 for each subspectrum of the source     
                                                                        
!     The source is normalized to 1 -> integral Trace(rho) dE =1
!     
        do i=-nSC,nSC 
         nn=iput+6*(i+nSC) 
          sTr(i)=aimag(array_fr(nn+1))
        end do

        hr=0. 
        do i=-nSC+1,nSC-1,2 
         hr=hr+ sTr(i)*2 
        end do 
        do i=-nSC+2,nSC-2,2 
         hr=hr+sTr(i) 
        end do 
        hr=hr*2.+ sTr(-nSC)+sTr(nSC); hr=hr/3. 

       do i=-nSC,nSC 
        nn=iput+6*(i+nSC) 
        array_fr(nn+1)=cmplx(real(array_fr(nn+1)),sTr(i))/hr 
        array_fr(nn+2)=array_fr(nn+2)/hr
       end do
 
      deallocate(cLG,sTr)

      return 
      END                                           

     subroutine rhoz(iput,nSC)
!    iput is the pointer iput of 
!    subroutine th_22indexsource(isubthe,icase,iput,iput,info)
!    of the first call (source site 1)

     use glbconst, only: enwr
     use comthe, only: array_fr
     implicit none 
     integer, intent(in)   :: iput,nSC
                                                                       
     integer   k,n,ni,nn     
     real      h,h1,h2,satrexpr,trs,p1s,p2s,p3s

     complex  app,apm,amp
     complex, dimension(4)  :: aa,bb,dd,as  
     complex, dimension(:), allocatable :: array
     real,    dimension(:), allocatable :: ah

!       wi=0.372*strength(1)   ! 1mu alpha-iron, natural abundance 57Fe
       allocate(array(4*(nSC+1))) 
       if(enwr(16).eq.'feff')then   ! command>st 16_feff
        allocate(ah(-nSC:nSC)) 
         h=0.
         as=(0.,0.)
         do n=-nSC,nSC 
          nn=iput+6*(n+nSC)
          satrexpr=exp(-aimag(array_fr(nn+3)*2))
          app=array_fr(nn+4)
          apm=array_fr(nn+5)
          amp=array_fr(nn+6)
          dd(1)=aa(1)

          call expo_22(app,apm,amp,aa)
           do k=1,4 
            dd(k)=aa(k) 
           end do
          bb(1)=conjg(dd(1)) 
          bb(4)=conjg(dd(4)) 
          bb(2)=conjg(dd(3)) 
          bb(3)=conjg(dd(2)) 
          ! bb=aa+ , dd=aa
          call matprof(bb,dd,aa) 

          dd(1)=aa(1)*satrexpr 
          dd(2)=aa(2)*satrexpr 
          dd(3)=aa(3)*satrexpr 
          dd(4)=aa(4)*satrexpr ! dd=aa+*aa *satrexpr

          trs=aimag(array_fr(nn+1))
          p1s=  real(array_fr(nn+2))
          p2s=aimag(array_fr(nn+2))
          p3s=  real(array_fr(nn+1))
          bb(1)=cmplx(trs+p3s,0.); bb(4)=cmplx(trs-p3s,0.)
          bb(2)=cmplx(p1s,p2s); bb(3)=conjg(bb(2)) 
          ! bb=rho  

          call matprof(bb,dd,aa)
          h=h+0.5*real(aa(1)+aa(4))  ! 1/2*Tr(rho*aa+*aa)
          ah=h
         end do
         h=0. 
         do n=-nSC+1,nSC-1,2 
          h=h+ ah(n)*2 
         end do 
         do n=-nSC+2,nSC-2,2 
          h=h+ah(n) 
         end do 
         h=h*2.+ ah(-nSC)+ah(nSC); h=h/6./nSC 

 
         print'(a,f12.3)','f-factor',h
        deallocate(ah)
       end if

!       rho(E,d)=satrexpr*exp-iA)*rho*exp(iA+) 
!       rho(E,d)=satrexpr*exp-iA)*(Sum_i ps(i)sig(i))*exp(iA+) 
!       sig(0)=(1 0/0 1), 
!       sig(1)= (0 1 /1 0), sig(2)=(0 -i/i 0), sig(3)=1 0/0 -1) 
!   rho(E,d)=satrexpr*Sum_i ps(i)* {exp-iA)*ps(i)*exp(iA+)}

!      Fortran  ( 1 3 )     convention                                  
!               ( 2 4 )                       
         do n=-nSC,nSC 
          nn=iput+6*(n+nSC)
          satrexpr=exp(-aimag(array_fr(nn+3)*2))
          app=array_fr(nn+4)
          apm=array_fr(nn+5)
          amp=array_fr(nn+6)
          call expo_22(app,apm,amp,aa)
          do k=1,4 
           dd(k)=aa(k) 
          end do

!         aa=exp(-iA)
!         bb=exp( iA+)
!         calculation of the {exp-iA)*ps(i)*exp(iA+)}=aa*ps(i)*bb
!         Fortran  ( 1 3 )     convention                                  
!                  ( 2 4 )                
          bb(1)=conjg(dd(1)) 
          bb(4)=conjg(dd(4)) 
          bb(2)=conjg(dd(3)) 
          bb(3)=conjg(dd(2)) 
          ! a+ = bb 
          
          h1=real(array_fr(nn+1)); h2=aimag(array_fr(nn+1))
          dd(1)=cmplx(h1+h2,0.); dd(4)=cmplx(-h1+h2,0.)
          dd(3)=array_fr(nn+2); dd(2)=conjg(dd(3))
          ! aa*dd*aa+    hermitian  since dd=dd+
          call matprof(aa,dd,as); call matprof(as,bb,dd)  

          h1=real(dd(1)-dd(4)); h2=real(dd(1)+dd(4))
          if(n.ge.0)then
           ni=4*n
           array(ni+1)=0.5*cmplx(h1,h2)*satrexpr
           array(ni+2)=dd(3)
          end if
          if(n.le.0)then           
           ni=-4*n
           array(ni+3)=0.5*cmplx(h1,h2)*satrexpr
           array(ni+4)=dd(3)
          end if 
         end do 
         do n=1,4*(nSC+1) 
          array_fr(iput+n)=array(n) 
         end do 
        deallocate(array)     

!         do n=0,6 
!           nn=iput+4*n 
!          write(6,'(1x,i8,4f15.6)')nn, &
!                aimag(array_fr(nn+1)), real(array_fr(nn+1))
!          end do 

       return
       end
