*?>?? logical, parameter :: debug = .false.
      Program msdpowder
      real noverk,cosk,sincos,tzz,eta
      double precision fac
      character chin*132
      dimension out(32)

      tzz=1.0
      eta=0.
 10   j=0
      write(6,'(2(a,f10.2))')' t_zz=',tzz,'   eta=', eta
      write(6,'(a)')'new tzz/return'
      READ(5,'(a)') chin
      call trlch(24,chin,iout,out)
      if(iout.eq.1) then
       tzz=out(1)
       j=1
      end if
      write(6,'(a)')'new eta/return'
      READ(5,'(a)') chin
      call trlch(24,chin,iout,out)
      if(iout.eq.1) then
       eta=out(1)
       j=1
      end if

      if(j.gt.0)goto 10
      write(6,'(a)')' n       summand        sum'
      hh=1.
      tzz=-tzz
      do n=1,18
      h=0.

      do k=0,n
      do j=0,n-k
       h=h+noverk(n,k)*noverk(n-k,j)*3**j*eta**k*cosk(k)*(-1)**(n-k-j)*
     &                 sincos(j,k)
      end do
      end do

      h=h*(0.5)**n/fac(float(n))
      hh=hh+h*tzz**n/2.                       ! /4pi
      write(6,'(i3,4f12.4)')n,h,hh

      end do
c      do j=0,10
c      do k=0,10
c       write(6,'(2i3,4f12.4)')j,k,sincos(j,k)
c      end do
c      end do
      stop
      end


      real function noverk(n,k)
c     n!/k!/(n-k)!
c     n*(n-1)*(n-2)...(n-k+1)/1*2*...(n-k)
      if(k.eq.0.or.k.eq.n) then
       noverk=1.
       return
      end if
      i=n-k
      j=n
      h=1.
      do while(i.gt.0)
       h=h*j/float(i)
c       write(6,'(2i3,f10.1)')j,i,h
       j=j-1
       i=i-1
      end do
      noverk=h
      return
      end

      function fac(x)
c     this function camculates the faculty up to 18
      double precision fac,f
      dimension f(19)

      data f/1.d0,1.d0,2.d0,6.d0,24.d0,120.d0,720.d0,5040.d0,
     &       40320.d0,362880.d0,36288.d2,  399168.d2,4790016.d2,
     &       62270208.d2,87178291.d3,1307674365.d3,2092278984.d4,
     &       35568742728.d4,640237369104.d4/
      n=x
      if(n.lt.0) stop
      fac=f(n+1)
      return
      end

      real function cosk(k)
      h=1.
      j=k
      do while(j.gt.0)
       h=h*(j-1)/j
       j=j-2
      end do
      cosk=h
      return
      end

      real function sincos(j,k)
      h=2.
      i=2*j
      l=2*k

      do while(i.gt.0)
       h=h*(i-1)/(i+l+1)
       i=i-2
      end do
      do while(l.gt.0)
       h=h*l/(l+1)
       l=l-2
      end do
      sincos=h

      cosk=h
      return
      end

      subroutine trlch(n_ch,chin,iout,out)
      character chin*132,ch*132
      dimension out(32)
      integer nch,n_ch
c     program translates numbers (all possible fortran formates,
c     separated by at least one blank or other character) given as ch*132
c     to iout real numbers (max.32) stored in the vector out.
c     nch characters of ch(1:nch) are analysed.
      nch=n_ch
      if(nch.gt.132) nch=132
      ch=chin
      i0=ichar('0')
      nsig=1
      pt=1.
      k1=0
      k2=0
      nex=0
      nnum=0
      iout=0
      do k=1,32
       out(k)=0.
      end do

      k=0
   10 k=k+1
      i=ichar(ch(k:k))-i0
      if(i.ge.0.and.i.lt.10) then
       nnum=1
       if (pt.eq.1.) then
        out(iout+1)=out(iout+1)*10.+float(i)
       else
        out(iout+1)=out(iout+1)+float(i)*pt
        pt=pt/10.
       end if
       if(k.eq.nch) goto 50
       goto 100
      end if

      if(ch(k:k).eq.'e'.or.ch(k:k).eq.'E') then
       if(nex.eq.1) goto 50
       do i=k-1,1,-1
        if(ch(i:i).eq.'.') then
         nex=-1
         goto 50
        end if
        ic=ichar(ch(i:i))-i0
        if(ic.lt.0.or.ic.gt.9) goto 100
       end do
      end if

      if(pt.lt.1.)then
       k=k-1
       goto 50
      end if

      if (ch(k:k).eq.'.') then
        pt =0.1
        goto 100
      end if
      if(ch(k:k).eq.'-') then
        if(nsig.eq.1) k1=k
        if(nsig.eq.-1) k2=k
        nsig=-1
      end if
      if(nnum.eq.1) goto 50
      if(nex.eq.1.and.ch(k:k).eq.' ') nex=0
      goto 100

   50 if(k1.lt.k) then
       out(iout+1)=nsig*out(iout+1)
       if(k2.lt.k1) then
        nsig=1
       else
        k1=k2
       end if
      end if
      nnum=0
      pt=1.
      if (nex.le.0) goto 60
      out(iout)=out(iout)*10.**out(iout+1)
      nex=0
      out(iout+1)=0.
      iout=iout-1
   60 if (iout.eq.32) goto 110
      iout=iout+1
      k1=0
      k2=0
      if(nex.eq.-1) nex=1

  100 if(k.lt.nch) goto 10
  110 return
      end
